// dib.cpp

// Our simple dibsection interface functions
// Called by main.c to access the window
// Uses my DIBSection class, that doesn't require DirectDraw. I tried making a windowed
// DirectDraw version, but it wasn't really any faster. Hopefully someone can get it going faster.

// Copr. 1998 - Justin Frankel/Nullsoft, Inc. (http://www.nullsoft.com)

#include <windows.h>

// Use easy DIBSection class
#include "dibsection.h"


static CDIBSection *dib;	// our DIB. Note that this is a generalized type (8bpp or 16bpp). 
							// we'll create it as a 16bpp DIB later on

// make our functions C callable so we can use them from main.c (not .cpp :)
extern "C" 
{

void dibinit(HWND hwnd, int w, int h)
{
	RECT r = {0,0,w,h};	// Create the DIB the size of the video mode
	dib = new CDIBSection16(hwnd,&r);	// Create a 16bpp DIB section
}

void dibquit()
{
	delete dib;	// delete our DIB
}

short *dibgetbuf()
{
	return (short *) dib->GetBuffer();	// Get the framebuffer for our DIB
}

void dibupdate()
{
	dib->Update();		// render our DIB to screen
}

int dibgetpitch()
{
	return dib->GetPitch()*2; // get the pitch of the DIB, in bytes
}

} // extern "C"
